config/routes.rb
# Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

Rails.application.routes.draw do
  mount AuthenticatedApp::Engine => "/auth"

  get '/join' => "enrollments#join"
  post '/join' => "enrollments#create"

  get 'messages' => "messages#index"

  root "root#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  include AuthenticatedApp::UserAuthentication
  include AuthenticatedApp::UserRecoveryEmail

  validates :username, presence: true, uniqueness: true
  validates :email, presence: true, uniqueness: { case_sensitive: false }

  before_validation { self.email&.downcase! }

  def login
    username
  end

  def is_active?
    true
  end

  def is_suspended?
    false
  end

  def is_pending?
    false
  end

  def self.find_by_login(login)
    find_by(username: login) || find_by(email: login)
  end

  def self.enroll_user(params)
    transaction do
      create!(username: params.require(:username),
              email: params.require(:email))
        .update_password!(password: params.require(:password),
                          password_confirmation: params.require(:password_confirmation))
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  include AuthenticatedApp::ControllerConcern

  def is_authorized?(user)
    true
  end
end

app/controllers/enrollments_controller.rb
class EnrollmentsController < ApplicationController
  skip_before_action :require_authentication

  def join
  end

  def create
    User.enroll_user(params)
    redirect_to(root_path, notice: "Thank you. Please sign in.")
  rescue ActiveRecord::RecordInvalid => invalid_err
    @errors = invalid_err.record.errors
    render :join
  rescue AuthenticatedApp::PasswordUpdateError => password_err
    @errors = password_err.errors
    render :join
  end
end

app/controllers/messages_controller.rb
class MessagesController < ApplicationController
  def index
  end
end

app/controllers/root_controller.rb
class RootController < ApplicationController
  skip_before_action :require_authentication
  before_action :optional_authentication

  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def user_signed_in?
    controller.current_user.present?
  end
end

app/helpers/messages_helper.rb
module MessagesHelper
end

app/views/enrollments/join.html.haml
.row.justify-content-center
  .col.col-md-6
    = form_with url: join_path, method: :post do |form|
      .form-group
        = form.label :username, "Username:"
        = form.text_field :username, value: params[:username], class: 'form-control', required: true
        - if @errors&.has_key?(:username)
          %small.form-text.text-muted= @errors.full_messages_for(:username).join("\n")
      .form-group
        = form.label :email, "Email:"
        = form.email_field :email, value: params[:email], class: 'form-control', required: true
        - if @errors&.has_key?(:email)
          %small.form-text.text-muted= @errors.full_messages_for(:email).join("\n")
      .form-group
        = form.label :password, "Password:"
        = form.password_field :password, class: 'form-control', required: true
        - if @errors&.has_key?(:password)
          %small.form-text.text-muted= @errors.full_messages_for(:password).join("\n")
      .form-group
        = form.label :password_confirmation, "Password confirmation:"
        = form.password_field :password_confirmation, class: 'form-control', required: true
        - if @errors&.has_key?(:password_confirmation)
          %small.form-text.text-muted= @errors.full_messages_for(:password_confirmation).join("\n")
      = form.submit "Submit", class: 'btn btn-primary'

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{:content => "text/html; charset=UTF-8", "http-equiv" => "Content-Type"}/
    %title Keys2nowhere
    %meta{:content => "width=device-width,initial-scale=1", :name => "viewport"}/
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag "application", "data-turbo-track": "reload"
    = javascript_importmap_tags
  %body.p-2
    .container
      = yield

app/views/messages/index.html.haml
%h1 Messages#index
%p Find me in app/views/messages/index.html.haml

app/views/root/index.html.haml
.row.justify-content-center
  .col
    %h1.w-100 Welcome to Keys 2 Nowhere!
    %h6 The authentication test application that can log you in

- if flash[:notice]
  .row
    .col
      .alert.alert-primary.alert-dismissible.fade.show{ role: "alert"}
        %p= flash[:notice]
        %button.close{ type: 'button', data: { dismiss: 'alert' }, aria: { label: 'Close' } }
          %span{ aria: { hidden: 'true' } } 🗙

.row.mt-2.button-row
  .col
    - if user_signed_in?
      %a.btn.btn-outline-info{ :href => authenticated_app.passwords_path } Account
      = form_with url: authenticated_app.session_path, method: :delete, class: 'd-inline' do |form|
        = form.submit 'Logout', class: 'btn btn-outline-dark'
    - else
      %a.btn.btn-outline-primary{ :href => join_path } Signup
      %a.btn.btn-outline-secondary{ :href => authenticated_app.new_session_path } Login